{----------------------
   Winamp'
"  "
  
www.IvanFDC.narod.ru
FDC@tut.by
----------------------}

library KeybLight;
uses Windows;
const
  VIS_HDRVER = $002;
  szAppName = 'SampleVisPlugin';
  descr = '  '; // 
  mod1_descr = '  ';
type
  //   
  PwinampVisModule = ^winampVisModule;
  //      
  waFunc = function( thismod: PwinampVisModule ): integer;cdecl;
  waProc = procedure( thismod: PwinampVisModule );cdecl;
  // 
  winampVisModule = record
    description: PChar;
    hwndParent: HWND;
    hDllInstance: HWND;
    sRate: integer;
    nCh: integer;
    latencyMs: integer;
    delayMs: integer;
    spectrumNch: integer;
    waveformNch: integer;
    spectrumData: array[0..1, 0..575] of byte;
    waveformData: array[0..1, 0..575] of byte;
    Config: waProc;
    Init: waFunc;
    Render: waFunc;
    Quit: waProc;
    userData: pointer;
  end;
    // 
    PwinampVisHeader = ^winampVisHeader;
    winampVisHeader = record
      version: integer;
      description: PChar;
      getModule: function( which: integer ): PwinampVisModule;cdecl;
    end;
var
    hdr: winampVisHeader;
    mod1: winampVisModule;
//      
Procedure SetLock(n, state:byte);
var
  KS: TKeyboardState;
  c: byte;
begin
  case n of
    0: c:=VK_NUMLOCK;
    1: c:=VK_CAPITAL;
    2: c:=VK_SCROLL;
  end;
  GetKeyboardState(KS);
  KS[c]:=state;
  SetKeyboardstate(KS);
end;
function getModule( which: integer ): PwinampVisModule;cdecl;
begin
  case which of
    0: result:=pointer( @mod1 );
  else result:=nil
  end;
end;
//   Winamp'
function winampVisGetHeader: PwinampVisHeader;cdecl;
begin
  result:=@hdr;
end;
//       ""
procedure config( this_mod: PwinampVisModule );cdecl;
begin
  MessageBox(this_mod.hwndParent, '   (FDC@tut.by)'+#13+'   http://www.IvanFDC.narod.ru', '  ', MB_OK)
end;
// ,   ,    0
function init( this_mod: PwinampVisModule ): integer;cdecl;
begin
  result:=0;
end;
//     
function render( this_mod: PwinampVisModule ): integer;cdecl;
var
  i:byte;
begin
  for i:=0 to 2 do
    if this_mod.spectrumData[0,i]>40 then SetLock(i, 1)
    else SetLock(i, 0);
  result:=0;
end;
//    
procedure quit( this_mod: PwinampVisModule );cdecl;
begin
end;
// 
exports
    winampVisGetHeader;
begin
    //     
    hdr.version:=VIS_HDRVER;
    hdr.description:=PChar(descr);
    hdr.getModule:=getModule;
    mod1.description:=PChar(mod1_descr);
    mod1.hwndParent:=0;
    mod1.hDllInstance:=0;
    mod1.sRate:=0;
    mod1.nCh:=0;
    mod1.latencyMs:=25;
    mod1.delayMs:=25;
    mod1.spectrumNch:=2;
    mod1.waveformNch:=0;
    mod1.Config:=@config;
    mod1.Init:=@init;
    mod1.Render:=@render;
    mod1.Quit:=@quit;
end.

